#ifndef TIMECONTR_H
#define TIMECONTR_H

#include <stdio.h>
#include "gfunct.h"
#include "iotools.h"

/**
   class timecontr controles time in problems with time
   
   JK
*/

class timecontr
{
 public:
  timecontr (void);
  ~timecontr (void);
  void read (XFILE *in);
  void print (FILE *out);
  double newtime ();
  double newtime (double &dt);
  void oldtime ();
  double starttime ();
  double endtime ();
  double actualtime ();
  double actualforwtimeincr ();
  double actualbacktimeincr ();
  double initialtimeincr ();
  void take_values (timecontr &tc);
  void seconds_days ();
  long isitimptime ();
  void initiate (timecontr &tc);
  void save_txt (FILE *out, int prec);
  void save_bin (FILE *out);
  void restore_txt (FILE *in);
  void restore_bin (FILE *in);
  //void reduce_step (double rf);
  
  ///  actual time
  double time;
  ///  actual backward time step
  double bdt;
  ///  actual forward time step
  double fdt;
  ///  backup of forward time step
  double bfdt;
  ///  starting time
  double start_time;
  ///  end time
  double end_time;
  ///  function describing time increments
  gfunct timefun;
  ///  array of important times
  double *imptime;
  ///  number of important times
  long nit;
  ///  actual position in imptime array
  long apit;
  ///  is it important time now?
  ///  iiit=0 - no
  ///  iiit=1 - yes
  long iiit;
  
  ///  type of time controller
  timecontrtype tct;
  ///  minimum time step
  double dtmin;
  ///  maximum time step
  double dtmax;
  
};

#endif
